//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef COMMON_HH
# define COMMON_HH

// Hold program name
extern const char *program_name;

// Manage exit status
enum exit_type
{
  exit_success = 0,
  exit_failure = 1,
  exit_scan = 2,
  exit_parse = 3,
  exit_solve = 4,
  exit_runtime = 5
};
extern exit_type exit_status;

inline void
exit_set (exit_type estatus)
{
  if (!exit_status || estatus < exit_status)
    exit_status = estatus;
}

#endif // !COMMON_HH
