//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

//
// WARNING: Generated file, do not edit by hand!
//

/** \file inst/lui.hh
    \brief Declare the interface of Lui */
#ifndef INST_LUI_HH
# define INST_LUI_HH

# include "inst/register.hh"
# include "inst/exp.hh"
# include "inst/inst.hh"

namespace inst
{

  /// Declare Lui.
  /** Move the constant imm into the upper half word of 
dest.  */
  class Lui:
    public Inst
  {
    /** \name Ctor & dtor.
        \{ */
  public:
    /// Construct a(n) Lui node.
    Lui(const Register &dest, const CountedExp &imm);
    /// Destroy a(n) Lui node.
    virtual ~Lui();
    /** \} */

    /** \name Accessors.
        \{ */
  public:
    /// Return dest
    const Register &		get_dest() const ;
    /// Return dest
    Register &		get_dest() ;
    /// Return imm
    const Exp &		get_imm() const ;
    /// Return imm
    Exp &		get_imm() ;
    /** \} */

    /** \name Visitors entry point.
        \{ */
  public:
    /// Accept a const visitor \a v.
    virtual void accept(ConstVisitor& v) const;
    /// Accept a non-const visitor \a v.
    virtual void accept(Visitor& v);
    /** \} */

  public:
    /// Print this
    virtual void	write(std::ostream &ostr) const;

  protected:
    Register	dest_;
    CountedExp	imm_;
  };

} // namespace inst

# include "inst/lui.hxx"

#endif // !INST_LUI_HH
