//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

//
// WARNING: Generated file, do not edit by hand!
//

/** \file inst/sra.hh
    \brief Declare the interface of Sra */
#ifndef INST_SRA_HH
# define INST_SRA_HH

# include "inst/register.hh"
# include "inst/exp.hh"
# include "inst/inst.hh"

namespace inst
{

  /// Declare Sra.
  /** Right-shift (arithmetic) the word src by the fixed number 
imm of bits and store the result in dest.  */
  class Sra:
    public Inst
  {
    /** \name Ctor & dtor.
        \{ */
  public:
    /// Construct a(n) Sra node.
    Sra(const Register &dest, const Register &src, const CountedExp &imm);
    /// Destroy a(n) Sra node.
    virtual ~Sra();
    /** \} */

    /** \name Accessors.
        \{ */
  public:
    /// Return dest
    const Register &		get_dest() const ;
    /// Return dest
    Register &		get_dest() ;
    /// Return src
    const Register &		get_src() const ;
    /// Return src
    Register &		get_src() ;
    /// Return imm
    const Exp &		get_imm() const ;
    /// Return imm
    Exp &		get_imm() ;
    /** \} */

    /** \name Visitors entry point.
        \{ */
  public:
    /// Accept a const visitor \a v.
    virtual void accept(ConstVisitor& v) const;
    /// Accept a non-const visitor \a v.
    virtual void accept(Visitor& v);
    /** \} */

  public:
    /// Print this
    virtual void	write(std::ostream &ostr) const;

  protected:
    Register	dest_;
    Register	src_;
    CountedExp	imm_;
  };

} // namespace inst

# include "inst/sra.hxx"

#endif // !INST_SRA_HH
