//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef SHELL_SHELL_HXX
# define SHELL_SHELL_HXX

# include "shell/shell.hh"

# include "misc/has.hh"

namespace shell
{

  //
  inline int
  Shell::get_register(const std::string &r)
  {
    if (r == "pc")
      return vm_.get_cpu().get_pc();
    // FIXME: assert r exists
    return vm_.get_cpu().get_register(map_register_[r]);
  }

  //
  inline void
  Shell::add_display(const std::string &r)
  {
    list_displayable_.push_back(r);
  }

  inline void
  Shell::remove_display(const std::string &r)
  {
    list_disp_type::iterator i = find(list_displayable_, r);
    //       for (i = list_displayable_.begin(); i != list_displayable_.end(); ++i)
    // 	if (*i == *r)
    // 	  break;
      
    if (i != list_displayable_.end())
      {
	list_displayable_.erase(i);
      }
  }

  inline void
  Shell::display()
  {
    for (list_disp_type::const_iterator
	   i = list_displayable_.begin(); i != list_displayable_.end(); ++i)
      std::cout << *i << " = " << get_register(*i) << std::endl;
  }

} // namespace shell

#endif // !SHELL_SHELL_HXX
