//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2006 Akim Demaille <akim@epita.fr> and
//		            Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef TASK_INT_TASK_HH
# define TASK_INT_TASK_HH

#include "task/task.hh"

namespace task
{

  class IntTask:
    public Task
  {
  public:
    IntTask(int &var, int min, int max,
	    const std::string &option, const std::string &module_name,
	    const std::string &desc, const std::string &deps = "");

  public:
    virtual bool set_value(const std::string &value) const;

  public:
    virtual void execute() const;

  private:
    mutable int value_;
    mutable int &var_;
    int min_;
    int max_;
  };

} // namespace task

#endif // !TASK_INT_TASK_HH
