//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef TASK_TASK_HXX
# define TASK_TASK_HXX

# include "task/task.hh"

namespace task
{

  //
  inline
  Task::~Task()
  {
  }

  //
  inline const std::string &
  Task::long_opt() const
  {
    return long_opt_;
  }
  inline const std::string &
  Task::short_opt() const
  {
    return short_opt_;
  }

  inline const std::string &
  Task::module() const
  {
    return module_;
  }
    
  inline const std::string &
  Task::description(void) const
  {
    return description_;
  }

  inline const Task::deps_type &
  Task::dependencies(void) const
  {
    return dependencies_;
  }

  inline bool
  Task::needs_value() const
  {
    return needs_value_;
  }

} // namespace task

#endif// !TASK_TASK_HH
