//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef VM_SEGMENT_HH
# define VM_SEGMENT_HH

# include <stdint.h>

namespace vm
{

  class Segment
  {
  public:
    Segment(int size = 0);
    ~Segment();

  public:
    void resize(int new_size);

    int size() const;

  public:
    void store_byte(int offset, int b);
    void store_word(int offset, int w);

  public:
    int load_byte(int offset) const;
    int load_word(int offset) const;

  protected:
    int size_;
    uint8_t* bytes_;
  };

} // namespace vm

# include "vm/segment.hxx"

#endif // !VM_SEGMENT_HH
